;*******************(C) COPYRIGHT 2019 Masses-Chip ******************************
;* File Name          : M8P516_Touch_Lib_Data.INC
;* Author             : MASSES CHIP
;* Version            : V1.03
;* Date               : 2019/08/22
;********************************************************************************


;================================================================================ 
#include     M8P516_Touch_Lib_CFG.h 

;================================================================================ 
       

;================================================================================ 
;触摸库RAM分配起始地址，不建议修改，或保证修改后有足够地址分配到触摸库使用
; RAM (0x3f+1-7-13-4*TKLib_OPENED_TK_AMOUNT)~0x3f 被触摸库中使用
group1 udata (0x3f+1-7-13-4*TKLib_OPENED_TK_AMOUNT-2*TKLib_TouchLowerPower*TKLib_OPENED_TK_AMOUNT)  

;================================================================================ 
_RTkTemp0        res        1
_RTkTemp1        res        1 
_RTkTemp2        res        1 
_RTkTemp3        res        1 
_RTkTemp4        res        1
_RTkTemp5        res        1
_RTkTemp6        res        1          
    
;以上RAM不调用触摸相关函数模块时，将释放使用，用户可以在其他程序中当临时变量使用

;以下RAM为不可释放RAM,消耗数量为 11+4*TKLib_OPENED_TK_AMOUNT,其中TKLib_OPENED_TK_AMOUNT为开启的按键数量      
_RTkBuff0        res        1        
_RTkBuff1        res        1 
_RTkBuff2        res        1     
_RTkBuff3        res        1 
_RTkBuff4        res        1        
_RTkBuff5        res        1 
_RTkBuff6        res        1 
_RTkBuff7        res        1 

#if  TKLib_OPENED_TK_AMOUNT
_RTkGBuff0       res        2*TKLib_OPENED_TK_AMOUNT                  
_RTkGBuff1       res        1*TKLib_OPENED_TK_AMOUNT
_RTkGBuff2       res        1*TKLib_OPENED_TK_AMOUNT       
#endif

#if TKLib_TouchLowerPower 
_RTkLPGBuff0     res        2*TKLib_OPENED_TK_AMOUNT
#endif

_RTKCBTFlag      res        1
_RTKLBTFlag      res        1
_RChannelEn      res        1 
_RKeyOnFlg       res        1   
_RTkBitFlag      res        1  

;================================================================================  
; 程序区 0x03f4~0x03ff，用户不可使用
;================================================================================ 
#if TKLib_TouchLowerPower
TAB_TOUCH_TKLP_CFG_DATA:
 org    (0x03ff+1-5-7-1)
TAB_TOUCH_TKLP_LP_SLEEPTIME:
 RETIA     (TKLib_LP_SLEEPTIME&0xff)
#endif

TAB_TOUCH_CFG_DATA:
 org    (0x03ff+1-5-7)                   
TAB_TOUCH_TK_EN_MASK_DATA:
 DW     TKLib_TK_EN_MASK
 
TAB_TOUCH_TKCKS_And_Scan_SW_DATA: 
 DW     (((TKLib_TKMODE&0x01)<<3)+(0x01<<7)+((TKLib_TKCKS&0x03)<<4)+((TKLib_OPENED_TK_AMOUNT&0x0F)<<8)) 
 
TAB_TOUCH_TKCAPS_DATA: 
 DW     (((TKLib_TK_VCS&0x03)<<6)+((TKLib_TK_VCHG&0x03)<<4))
 
TAB_TOUCH_NUM_DATA:  
 DW     ((TKLib_Down_Calibration_Rate&0x07)+((TKLib_Up_Calibration_Rate&0x07)<<4)+((TKLib_LONG_TOUCH_TIME&0x0F)<<12) +((TKLib_TOUCH_NUM&0x07)<<8)+((TKLib_Multi_TOUCH_RST&0x01)<<11))

TAB_TOUCH_CONFIRM_TIME_DATA: 
 DW     ((TKLib_EFFECTIVE_TOUCH_TIME&0x0F)+((TKLib_INVALID_TOUCH_TIME&0x0F)<<4) +((TKLib_Debounce_TIME&0x0FF)<<8))

TAB_TOUCH_F_DATA:
 DW     ((0&0x0f)+((TKLib_TK0_F_THRESHOLD&0xff)<<8))
 DW     ((0&0x0f)+((TKLib_TK1_F_THRESHOLD&0xff)<<8))
 DW     ((0&0x0f)+((TKLib_TK2_F_THRESHOLD&0xff)<<8))
 DW     ((0&0x0f)+((TKLib_TK3_F_THRESHOLD&0xff)<<8))
 DW     ((0&0x0f)+((TKLib_TK4_F_THRESHOLD&0xff)<<8))  
 DW     ((0&0x0f)+((50&0xff)<<8))
 DW     (0x0309)
 
;================================================================================         
 ; RAM
 GLOBAL _RTkTemp0   
 GLOBAL _RTkTemp1   
 GLOBAL _RTkTemp2    
 GLOBAL _RTkTemp3   
 GLOBAL _RTkTemp4  
 GLOBAL _RTkTemp5      
 GLOBAL _RTkTemp6    

 GLOBAL _RTKCBTFlag    
 GLOBAL _RTKLBTFlag  
 GLOBAL _RTkBitFlag    
 GLOBAL _RKeyOnFlg   
 GLOBAL _RChannelEn    

 GLOBAL _RTkBuff0     
 GLOBAL _RTkBuff1  
 GLOBAL _RTkBuff2     
 GLOBAL _RTkBuff3 
 GLOBAL _RTkBuff4     
 GLOBAL _RTkBuff5 
 GLOBAL _RTkBuff6 
 GLOBAL _RTkBuff7
  
 GLOBAL _RTkGBuff0     
 GLOBAL _RTkGBuff1    
 GLOBAL _RTkGBuff2     

 ; CODE
 GLOBAL TAB_TOUCH_TK_EN_MASK_DATA 
 GLOBAL TAB_TOUCH_TKCAPS_DATA 
 GLOBAL TAB_TOUCH_TKCKS_And_Scan_SW_DATA           
 GLOBAL TAB_TOUCH_CONFIRM_TIME_DATA   
 GLOBAL TAB_TOUCH_NUM_DATA  
 GLOBAL TAB_TOUCH_F_DATA 
 
#if TKLib_TouchLowerPower 
 ; RAM 
 GLOBAL _RTkLPGBuff0     

 ; CODE
 GLOBAL TAB_TOUCH_TKLP_LP_SLEEPTIME          

#endif 

;================================================================================  
;以下信息用户可不查看
;================================================================================  
#if 1         ; 0:关闭触摸配置信息提示，1:开启触摸配置信息提示
;================================================================================
;CDC MODE
#if (TKLib_TKMODE > 1)
    Error "    Error: Please setting TKLib_TKMODE ∈ {0,1}  "  
#endif

#if (TKLib_TKMODE == 0)
    MESSG "    触摸工作模式: 电荷转移模式"  
#endif
#if (TKLib_TKMODE == 1)
    MESSG "    触摸工作模式: 振荡模式"   
#endif

;================================================================================
#if EnTk0
    MESSG "    TK0: Enable"  
#endif
#if EnTk1
    MESSG "    TK1: Enable"  
#endif
#if EnTk2
    MESSG "    TK2: Enable"  
#endif
#if EnTk3
    MESSG "    TK3: Enable"  
#endif

#if (TKLib_TKMODE == 1)
#if EnTk4
    MESSG "    TK4: Enable"  
#endif
#endif

#if (TKLib_TKMODE == 0)
#if EnTk4
    Error "    Error: 电荷转移模式下无此通道"  
#endif
#endif

;================================================================================
#if (TKLib_OPENED_TK_AMOUNT == 0)
    Error "    No channel is enabled,Please reconfigure EnTk0~EnTk4"  
#endif	

;================================================================================
;CDC clock
#if (TKLib_TKCKS > 3)
    Error "    Error: Please setting TKLib_TKCKS <= 3 "  
#endif

#if (TKLib_TKCKS == 0)
    MESSG "    CDC Clock: Fosc/4"  
#endif
#if (TKLib_TKCKS == 1)
    MESSG "    CDC Clock: Fosc/8"  
#endif
#if (TKLib_TKCKS == 2)
    MESSG "    CDC Clock: Fosc/16"  
#endif
#if (TKLib_TKCKS == 3)
    MESSG "    CDC Clock: Fosc/32" 
#endif

;================================================================================
#if (TKLib_TOUCH_NUM == 0)
    Error "    Error: Please setting TKLib_TOUCH_NUM > 0"  
#endif

;================================================================================
#if (TKLib_Debounce_TIME == 0)
    Error "    Error: Please setting TKLib_Debounce_TIME > 0"  
#endif
#if (TKLib_Debounce_TIME > 255)
    Error "    Error: Please setting TKLib_Debounce_TIME <= 255"  
#endif

;================================================================================
#if (TKLib_LONG_TOUCH_TIME == 0)
    MESSG "    屏蔽按键最长输出时间功能，即触摸不离开，按键标志一直会置位 " 
#endif
#if (TKLib_LONG_TOUCH_TIME == 1)
    Error "    禁止配置 " 
#endif
#if (TKLib_LONG_TOUCH_TIME > 15)
    Error "    Error: Please setting TKLib_LONG_TOUCH_TIME <= 15"  
#else
#if (TKLib_LONG_TOUCH_TIME > 1)
    MESSG "    开启按键最长输出时间功能，若触摸不离开，按键标志会输出一段时间后，会清零 " 
#endif
#endif

;================================================================================
#if (TKLib_Multi_TOUCH_RST > 1)
    Error "    Error: Please setting TKLib_Multi_TOUCH_RST ∈ {0,1}  "  
#endif

;================================================================================
#if (TKLib_Up_Calibration_Rate < 1)
    Error "    Error: Please setting TKLib_Up_Calibration_Rate >= 1" 
#endif
#if (TKLib_Up_Calibration_Rate > 7)
    Error "    Error: Please setting TKLib_Up_Calibration_Rate <= 7"  
#endif

#if (TKLib_Down_Calibration_Rate < 1)
    Error "    Error: Please setting TKLib_Down_Calibration_Rate >= 1" 
#endif
#if (TKLib_Down_Calibration_Rate > 7)
    Error "    Error: Please setting TKLib_Down_Calibration_Rate <= 7"  
#endif

;================================================================================
#if (TKLib_CaliBaseTime < 1)
    Error "    Error: Please setting TKLib_CaliBaseTime >= 1" 
#endif
#if (TKLib_CaliBaseTime > 254)
    Error "    Error: Please setting TKLib_CaliBaseTime <= 254"  
#endif

#if (TKLib_LongKeyBaseTime < 1)
    Error "    Error: Please setting TKLib_LongKeyBaseTime >= 1" 
#endif
#if (TKLib_LongKeyBaseTime > 254)
    Error "    Error: Please setting TKLib_LongKeyBaseTime <= 254"  
#endif

;================================================================================
#if (TKLib_EFFECTIVE_TOUCH_TIME == 0)
    Error "    Error: Please setting TKLib_EFFECTIVE_TOUCH_TIME > 0"  
#endif
#if (TKLib_EFFECTIVE_TOUCH_TIME > 15)
    Error "    Error: Please setting TKLib_EFFECTIVE_TOUCH_TIME <= 15"  
#endif

;================================================================================
#if (TKLib_INVALID_TOUCH_TIME == 0)
    Error "    Error: Please setting TKLib_INVALID_TOUCH_TIME > 0"  
#endif
#if (TKLib_INVALID_TOUCH_TIME > 15)
    Error "    Error: Please setting TKLib_INVALID_TOUCH_TIME <= 15"  
#endif

;================================================================================
#if (TKLib_TK0_F_THRESHOLD > 255)
    Error "    Error: Please setting TKLib_TK0_F_THRESHOLD <= 255"  
#endif
#if (TKLib_TK1_F_THRESHOLD > 255)
    Error "    Error: Please setting TKLib_TK1_F_THRESHOLD <= 255"  
#endif
#if (TKLib_TK2_F_THRESHOLD > 255)
    Error "    Error: Please setting TKLib_TK2_F_THRESHOLD <= 255"  
#endif
#if (TKLib_TK3_F_THRESHOLD > 255)
    Error "    Error: Please setting TKLib_TK3_F_THRESHOLD <= 255"  
#endif
#if (TKLib_TK4_F_THRESHOLD > 255)
    Error "    Error: Please setting TKLib_TK4_F_THRESHOLD <= 255"  
#endif

;================================================================================
#if (TKLib_TK0_F_THRESHOLD <6)
    Error "    Error: Please setting TKLib_TK0_F_THRESHOLD >= 6"
#endif
#if (TKLib_TK1_F_THRESHOLD <6)
    Error "    Error: Please setting TKLib_TK1_F_THRESHOLD >= 6"  
#endif
#if (TKLib_TK2_F_THRESHOLD <6)
    Error "    Error: Please setting TKLib_TK2_F_THRESHOLD >= 6"
#endif
#if (TKLib_TK3_F_THRESHOLD <6)
    Error "    Error: Please setting TKLib_TK3_F_THRESHOLD >= 6"
#endif
#if (TKLib_TK4_F_THRESHOLD <6)
    Error "    Error: Please setting TKLib_TK4_F_THRESHOLD >= 6"
#endif

;================================================================================
;CDC VCHG
#if (TKLib_TK_VCHG > 3)
    Error "    Error: Please setting TKLib_TK_VCHG <= 3 "  
#endif

#if (TKLib_TK_VCHG == 0)
    MESSG "    触摸充电电压: 2V"  
#endif
#if (TKLib_TK_VCHG == 1)
    MESSG "    触摸充电电压: 3V"   
#endif
#if (TKLib_TK_VCHG == 2)
    MESSG "    触摸充电电压: 4V"   
#endif
#if (TKLib_TK_VCHG == 3)
    MESSG "    触摸充电电压: VDD" 
#endif

;================================================================================
;CDC VCS
#if (TKLib_TKMODE == 0)
#if (TKLib_TK_VCS > 3)
    Error "    Error: Please setting TKLib_TK_VCS  ∈ {0,1,2,3} "  
#endif
#if (TKLib_TK_VCS == 0)
    MESSG "    触摸参考电压: 1.2V"  
#endif
#if (TKLib_TK_VCS == 1)
    MESSG "    触摸参考电压: 0.5 * 触摸充电电压"   
#endif
#if (TKLib_TK_VCS == 2)
    MESSG "    触摸参考电压: 0.75 * 触摸充电电压"   
#endif
#if (TKLib_TK_VCS == 3)
    MESSG "    触摸参考电压: 0.9 * 触摸充电电压" 
#endif
#else
#if (TKLib_TK_VCS > 3)
    Error "    Error: Please setting TKLib_TK_VCS  ∈ {1,2,3} "  
#endif
#if (TKLib_TK_VCS == 0)
    Error "    Error: Please setting TKLib_TK_VCS  ∈ {1,2,3} " 
#endif
#if (TKLib_TK_VCS == 1)
    MESSG "    触摸参考振荡频率: 低"   
#endif
#if (TKLib_TK_VCS == 2)
    MESSG "    触摸参考振荡频率: 中"   
#endif
#if (TKLib_TK_VCS == 3)
    MESSG "    触摸参考振荡频率: 高" 
#endif
#endif

;================================================================================
#if (TKLib_TouchLowerPower==1)
    MESSG "    触摸低功耗模式：已开启"  
    MESSG "    WDT使能选择需要选择：绿色或休眠模式" 
#endif   
#if (TKLib_TouchLowerPower>1)
    MESSG "    触摸低功耗模式：配置错误，TKLib_TouchLowerPower ∈ {0,1} "	
#endif


;================================================================================
#endif

;*********************************END OF FILE************************************
